\section{Control Subsystem}

\def\subsystem{c}

This section describes in detail the controller designed in order to perform
the task described in \autoref{sec:task}.

\input{content/control-subsystem/data-structures}

\subsection{Finite State Machine}
One can find in this subsection the definition of the finite state automaton
governing the control subsystem. The structure of the different states is
illustrated by \autoref{fig:control-FSM} in a formal way (a simple graph
where the nodes represent behaviours and arcs are labelled by predicates
representing initial conditions of behaviour execution).
\autoref{table:state-behaviour} defines the behaviours associated to each state
and their possible successors with the initial and terminal conditions. Each
behaviour is described in detail in \autoref{subsec:behaviours}.

Terminal conditions are stated in mathematical terms in
\autoref{table:control-terminal}, while it is assumed no error condition is
necessary, as described in \autoref{table:control-error}. It is easy to observe
that the initial conditions stated mathematical terms in
\autoref{table:control-initial} satisfy the \emph{Separability} and
\emph{Internality} conditions. The mathematical expressions refer to variables
defined in \autoref{subsec:data-structures}. Even if this  mathematical
expressions state an equality, this equality will be substituted in a real
system by a check that the absolute value difference of both members of the
equality is lower than a given tolerance.


\begin{figure}
    \centering
    \includegraphics[width=\textwidth]{FSM.jpg}
    % \input{content/control-subsystem/control-FSM-formal.tikz}
    \caption{Control subsystem Finite State Machine structure}
    \label{fig:control-FSM}
\end{figure}

\begin{table}
\centering
    \input{content/control-subsystem/state-behaviour-table.tex}
    \caption{Control subsystem states and behaviours correspondences}
    \label{table:state-behaviour}
\end{table}

\begin{table}
    \centering
    \begin{tabular}{l   l}
    Behaviour error conditions & 
        $\ferr{l} \triangleq \text{FALSE} \quad 
        l = 1,...,8$ \\
    \end{tabular}
    \caption{Control subsystem behaviours' error conditions}
    \label{table:control-error}
\end{table}

\begin{table}
    \centering
    \input{content/control-subsystem/control-initial-table.tex}
    \caption{Control subsystem states' sets of next states and initial conditions}
    \label{table:control-initial}
\end{table}

\begin{table}
    \centering
    \input{content/control-subsystem/control-terminal-table.tex}
    \caption{Control subsystem behaviours' terminal conditions}
    \label{table:control-terminal}
\end{table}

\clearpage
\subsection{Behaviours}
\label{subsec:behaviours}
\includepdf[pages=-, pagecommand= ]{handwritten-2020.pdf}

% spell-checker:disable
% General form B_p1 \triangleq B_pz(ftrans, fter, fini)
% Transition function memory^{i+1} := ftrans{c} \triangleq partial ftrans
% Partial transition function memory^{i+1}[var] := ftrans_1{c}(dependencies)
% Transition function memory^{i+1} = ftrans{c}
% \input{content/control-subsystem/behaviours.tex}